3 #########################################################################
4 # This program is free software: you can redistribute it and/or modify #
5 # it under the terms of the version 3 of the GNU General Public License #
6 # as published by the Free Software Foundation. #
8 # This program is distributed in the hope that it will be useful, but #
9 # WITHOUT ANY WARRANTY; without even the implied warranty of #
10 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU #
11 # General Public License for more details. #
13 # You should have received a copy of the GNU General Public License #
14 # along with this program. If not, see <http://www.gnu.org/licenses/>. #
16 # Written by and Copyright (C) Francois Fleuret #
17 # Contact <francois@fleuret.org> for comments & bug reports #
18 #########################################################################
20 # The site-specific and confidential settings are in another file
22 PRIVATE_BASHRC="${HOME}/private/bashrc.perso"
24 # If the MANPATH is not set, set it
26 [[ "${MANPATH}" ]] || MANPATH=$(manpath)
28 # If the private bashrc exists, execute it
30 [[ -f "${PRIVATE_BASHRC}" ]] && source "${PRIVATE_BASHRC}"
32 # !!! THIS HAS TO BE HERE EVEN IN THE NON-INTERACTIVE PART OR YOU WILL
33 # LOSE YOU PREVIOUS HISTORY !!!
35 export HISTFILESIZE=20000
36 export HISTSIZE=${HISTFILESIZE}
38 export HISTIGNORE="${HISTIGNORE}:&:[ ]*"
40 # I want to save the command time, but I do not want to see it in
43 export HISTTIMEFORMAT=""
47 # I realized that most of my settings are meaningful only in
48 # interactive mode. This should maybe be done more properly through
49 # using different .bash_profile and .bash_login
51 [ ${TERM} == "dumb" ] || [[ ! -t 0 ]] && return
53 # Remove the annoying beeps in console
57 # || setterm --blength 0 # Seriously?
59 ######################################################################
60 ## The interactive part
62 export VT_RESET=$'\e[0m'
63 export VT_BOLD=$'\e[1m'
64 export VT_UNDERLINE=$'\e[4m'
65 export VT_BLINK=$'\e[5m'
67 export VT_SET_TITLE=$'\e]0;'
68 export VT_END_TITLE=$'\007'
70 export VT_BLACK_FG=$'\e[30m'
71 export VT_RED_FG=$'\e[31m'
72 export VT_GREEN_FG=$'\e[32m'
73 export VT_YELLOW_FG=$'\e[33m'
74 export VT_BLUE_FG=$'\e[34m'
75 export VT_MAGENTA_FG=$'\e[35m'
76 export VT_CYAN_FG=$'\e[36m'
77 export VT_WHITE_FG=$'\e[37m'
79 export VT_BLACK_BG=$'\e[40m'
80 export VT_RED_BG=$'\e[41m'
81 export VT_GREEN_BG=$'\e[42m'
82 export VT_YELLOW_BG=$'\e[43m'
83 export VT_BLUE_BG=$'\e[44m'
84 export VT_MAGENTA_BG=$'\e[45m'
85 export VT_CYAN_BG=$'\e[46m'
86 export VT_WHITE_BG=$'\e[47m'
90 export LESS_TERMCAP_us=${VT_GREEN_FG}
91 export LESS_TERMCAP_ue=${VT_RESET}
92 export LESS_TERMCAP_md=${VT_BLUE_FG}${VT_BOLD}
93 export LESS_TERMCAP_me=${VT_RESET}
95 # I do not like to clutter my home with history files
97 export LESSHISTFILE=/dev/null
99 # export LESS_TERMCAP_md=$'\e[1;34;40m'
101 # This prevents ^S from freezing the shell
111 alias chmod='chmod -c'
117 # alias df='df -hT --sync'
118 alias grep='grep -i -E --color=auto'
119 alias find='ionice -c3 find'
121 alias val='valgrind --leak-check=full --show-reachable=yes --db-attach=yes '
123 alias s='screen -d -R -U && clear'
124 alias p='feh --force-aliasing -d --full-screen --auto-zoom'
127 export HISTFILE=/dev/null
131 function select-tz () {
132 # Select a value for TZ
133 TMP=$(mktemp /tmp/select-tz.XXXXXX)
134 selector -o "${TMP}" <(grep -v ^# /usr/share/zoneinfo/zone.tab | awk '{print $3}' | sort -u)
140 if [[ $1 ]] && which winshepherd.sh
142 play -q ~/local/sounds/deskbell.wav &
144 winshepherd.sh message green "$1"
146 play -q ~/local/sounds/deskbell.wav
150 alias impressive="impressive -s -D 1000 -t Crossfade -T 100"
152 if [[ -e "${HOME}/.dircolors" ]]
154 eval $(dircolors "${HOME}/.dircolors")
155 alias ls='ls -p --group-directories-first --color'
156 alias lt='ls -p --color -gohtr --time-style="+%Y %b %d %H:%M"'
157 alias ll='ls -p --color -goh --time-style="+%Y %b %d %H:%M"'
158 alias lll='ls -p --color -lth'
159 alias l='ls -p --color -I "*~" -I "*.o"'
162 alias ls='ls -p --group-directories-first'
163 alias lt='ls -p -gohtr --time-style="+%Y %b %d %H:%M"'
164 alias ll='ls -p -goh --time-style="+%Y %b %d %H:%M"'
165 alias lll='ls -p -lth'
166 alias l='ls -p -I "*~" -I "*.o"'
169 export EDITOR=emacsclient
170 export GIT_EDITOR=${EDITOR}
172 ######################################################################
173 # Ignored extensions when completing
175 # export FIGNORE="CVS"
177 function latexdiff () {
179 -w $'\033[30;41m' -x $'\033[0m' \
180 -y $'\033[30;42m' -z $'\033[0m' \
184 # Looks for the most recent .log and pdflatex + bibtex the
185 # corresponding tex file
188 # RECENT_LOG=$(ls -t $(find -maxdepth 1 -name "*.log" -type f) | head -1)
190 RECENT_LOG=$(ls -t *.log | head -1)
192 if [[ ${RECENT_LOG} ]]
194 FILEBASE="${RECENT_LOG/.log/}"
196 if [[ -f "${FILEBASE}.tex" ]]
199 pdflatex --shell-escape "${FILEBASE}"
201 pdflatex --shell-escape "${FILEBASE}"
202 pdflatex --shell-escape "${FILEBASE}"
206 if [[ "$1" == "-v" ]] || [[ "$1" == "--view" ]]
208 xpdf "${FILEBASE}.pdf"
209 elif [[ "$1" == "-p" ]] || [[ "$1" == "--print" ]]
211 lpr "${FILEBASE}.pdf"
213 echo "Usage: rl [-v|--view] [-p|--print]" >&2
214 echo "Unknown option $1" >&2
221 echo "Can not find a tex file corresponding to the most recent log (${RECENT_LOG/.log/})." >&2
227 echo "Can not find a recent log." >&2
233 ######################################################################
236 # http://www.reddit.com/r/linux/comments/2cgu5k/a_handy_little_script_for_interacting_with_your/
238 if [[ -t 0 ]] && [[ -z "$1" ]]
240 # output contents of clipboard
241 xclip -out -selection clipboard || exit 1
244 # copy file contents to clipboard
245 xclip -in -selection clipboard < "$1" || exit 1
247 # copy stdin to clipboard
248 xclip -in -selection clipboard <&0 || exit 1
252 # Find a file whose name contains a substring
257 find "$@" -name "*${name}*";
271 while [[ -f "${HOME}/scan-${n}.jpg" ]]
278 if [[ "$1" == "color" ]]
280 OPTS+=" --mode Color"
281 elif [[ "$1" == "gray" ]]
284 elif [[ "$1" == "a4crop" ]]
286 OPTS+=" -l 5 -t 0 -x 200 -y 300"
287 elif [[ "$1" == "help" ]] || [[ "$1" == "-h" ]] || [[ "$1" == "--help" ]]
289 echo "$0 [color|gray] [a4crop]" && return 0
291 echo "Unknown argument \`$1'"
297 echo "** Scanning to ${HOME}/scan-${n}.jpg"
300 SCANNER=$(scanimage -L | grep "Canon LiDE 60" | sed -e "s/^.*\`\(.*\)'.*$/\1/")
302 scanimage -d ${SCANNER} \
309 convert -rotate 180 - "${HOME}/scan-${n}.jpg"
314 # A password generator
317 tr -dc A-Za-z0-9 < /dev/urandom | head -c16
318 # tr -dc [:graph:] < /dev/urandom | head -c16
324 [[ "$1" ]] || ( echo "Universal unarchive: ua <file> [<file> ...]" >&2 && return 1)
330 *.tgz|*.tar.gz|*.tbz|*.tar.bz2)
343 echo "Unknown file extension $1"
352 # Create a dir and cd there
359 # Capture the screen in a dated png
366 name="capture-$(date +%s).png"
371 echo "Waiting $1 s and saving to ${name}."
374 echo "Saving to ${name}."
377 echo "Please click on the window to capture."
378 xwd | convert - ${name}
382 # Create and CD in a /tmp/tmp.XXXXXX directory. With the '-'
383 # arguments, do not create one and CD in the most recent instead
390 cd $(\ls -td /tmp/tmp.?????? | head -1)
392 echo "USAGE: cdt [-]" >&2
396 dir=$(mktemp -d /tmp/tmp.XXXXXX)
402 if [[ ! -a ${link} ]]
414 TRASH=$(date +/tmp/trash-${USER}-%Y-%b-%d-%Hh)
419 [[ -h ${LINK} ]] && \rm ${LINK}
421 [[ ! -f ${LINK} ]] && ln -s ${TRASH} ${LINK}
427 ######################################################################
428 ## A version of pho which stores the image numbers in environment
432 TEMP=$(mktemp /tmp/pho.XXXXXXX)
433 $(which pho) "$@" | tee ${TEMP}
434 PHO_NOTE_1=$(grep ^"Note 1: " ${TEMP} | sed -e "s/^[^:]*: //")
435 PHO_NOTE_2=$(grep ^"Note 2: " ${TEMP} | sed -e "s/^[^:]*: //")
436 PHO_NOTE_3=$(grep ^"Note 3: " ${TEMP} | sed -e "s/^[^:]*: //")
437 PHO_NOTE_R90=$(grep ^"Rotate 90 \(CW\): " ${TEMP} | sed -e "s/^[^:]*: //")
438 PHO_NOTE_R180=$(grep ^"Rotate 180: " ${TEMP} | sed -e "s/^[^:]*: //")
439 PHO_NOTE_R270=$(grep ^"Rotate -90 \(CCW\): " ${TEMP} | sed -e "s/^[^:]*: //")
440 [[ "${PHO_NOTE_1}" ]] || unset PHO_NOTE_1
441 [[ "${PHO_NOTE_2}" ]] || unset PHO_NOTE_2
442 [[ "${PHO_NOTE_3}" ]] || unset PHO_NOTE_3
443 [[ "${PHO_NOTE_R90}" ]] || unset PHO_NOTE_R90
444 [[ "${PHO_NOTE_R180}" ]] || unset PHO_NOTE_R180
445 [[ "${PHO_NOTE_R270}" ]] || unset PHO_NOTE_R270
449 ######################################################################
450 ## A version of date that shows the time at home if TZ is set
453 echo "Local - $(date)"
455 echo "Home - $(date)"
458 ######################################################################
459 ## ifup / ifdown with sudo and memorization of the network
461 ## When invoked without an argument netup uses the same argument as
464 ## When invoked without an argument netdown removes the last interface
467 [ ${NETUP_HISTORY} ] || NETUP_HISTORY="${HOME}/.netup_history"
472 [[ "${WIFI_INTERFACE}" ]] || WIFI_INTERFACE=wlan0
474 if [[ "$1" == "--scan" ]]
476 if ifconfig -s | grep -v -q ${WIFI_INTERFACE}
478 sudo ifconfig ${WIFI_INTERFACE} up
482 sudo iwlist ${WIFI_INTERFACE} scan | \grep -E 'ESS|Quali|Encry' | sed -e 's/^[ \t]*//'
484 if [[ ${upped_wifi} ]]
486 sudo ifconfig ${WIFI_INTERFACE} down
493 if \ifconfig -s | grep -q -v ^'(Iface|lo) '
495 echo "There is/are already interface(s) up." >&2
499 if \ps h -C dhclient | grep -q .
501 echo "There is already a dhcp client running." >&2
505 if \ps h -C wpa_supplicant | grep -q .
507 echo "There is already a wpa_supplicant running." >&2
511 if [[ ! "$@" ]] && [[ -s ${NETUP_HISTORY} ]]
513 echo "netup <interface>" >&2
515 # # If we have no argument and there is a .netup_history, use it
516 # ARGS=$(cat ${NETUP_HISTORY})
518 # Otherwise uses the given arguments, and store them
520 echo ${ARGS} > ${NETUP_HISTORY}
523 if [[ "${PRIVATE_INTERFACE_DEFINITION}" ]]
525 ARGS="-i ${PRIVATE_INTERFACE_DEFINITION} ${ARGS}"
528 echo "Executing ${VT_GREEN_FG}[sudo ifup ${ARGS}]${VT_RESET}"
531 # Ugly hack to remove the dsl modem dns server when we add
532 # explicitely a dns in the /etc/network/interfaces
534 REMOVE_LOCAL_DNS=/usr/local/bin/remove-local-dns.sh
535 # REMOVE_LOCAL_DNS=${HOME}/sources/scripts/remove-local-dns.sh
537 if [[ -x ${REMOVE_LOCAL_DNS} ]]
539 echo "Executing ${VT_GREEN_FG}[sudo ${REMOVE_LOCAL_DNS} 192.168]${VT_RESET}"
540 sudo ${REMOVE_LOCAL_DNS} 192.168
544 function netdown () {
545 if [[ ! "$@" ]] && [[ -s ${NETUP_HISTORY} ]]
547 # If there are no arguments and there is a .netup_history, get the
549 ARGS=$(tail -1 ${NETUP_HISTORY} | sed -e "s/=.*$//")
551 # Otherwise, use the standard ifdown
555 [[ "${PRIVATE_INTERFACE_DEFINITION}" ]] && ARGS="-i ${PRIVATE_INTERFACE_DEFINITION} ${ARGS}"
557 echo "Executing sudo ${VT_GREEN_FG}[ifdown ${ARGS}]${VT_RESET}"
560 # if [[ $(\ps -C dhclient | tail -n +2) ]]
562 # echo "There is still a dhcp client running." >&2
566 # if [[ $(\ps -C wpa_supplicant | tail -n +2) ]]
568 # echo "There is still a wpa_supplicant running." >&2
573 function checkgw () {
574 GW=$(route -n | grep ^0.0.0.0 | awk '{print $2}')
579 echo "Can not find a getaway." >&2
584 ######################################################################
585 # Show the most recent files, no scroll
588 TERM_SIZE=($(stty size))
589 INVIS="${VT_GREEN_FG}${VT_RESET}"
590 \ls -goth --time-style="+${VT_GREEN_FG}%Y %b %d %H:%M${VT_RESET}" "$@" | \
591 head -$((TERM_SIZE[0]-2)) | cut -b1-$((TERM_SIZE[1]+${#INVIS}))
594 ######################################################################
598 # /screen selects low-resolution output
599 # /ebook selects medium-resolution output
600 # /printer selects "Print Optimized" setting.
601 # /prepress selects "Prepress Optimized" setting.
607 if [[ "$1" == "--help" ]] || [[ "$1" == "-h" ]]
609 echo "$0 [<file.pdf>|--quality <screen|ebook|printer|prepress>] ..."
612 elif [[ "$1" == "--quality" ]]
619 result="$(basename "$1" .pdf)-${quality}.pdf"
620 echo -n "Generating ${result} with quality ${quality} ... "
621 gs -sDEVICE=pdfwrite \
622 -dCompatibilityLevel=1.4 \
623 -dPDFSETTINGS=/${quality} \
624 -dColorConversionStrategy=/LeaveColorUnchanged \
625 -dNOPAUSE -dQUIET -dBATCH \
626 -sOutputFile="${result}" "$1"
628 ls -hl "$1" "${result}"
631 echo "Cannot fine $1"
638 ######################################################################
639 # You can change the xterm background color on the fly!
641 function setxtermbg () {
642 echo -n $'\e]11;'$1$'\007'
645 ######################################################################
646 # Shuffle the lines from the stdin
648 function shuffle () {
650 [[ $SEED ]] || SEED=0
651 awk 'BEGIN{srand('${SEED}')} { print rand()" "$0 }' | sort -g | sed -e "s/^[0-9\.e\-]* //"
654 ######################################################################
655 # Stores the last entered command into a file
657 KEPT_COMMANDS=${HOME}/.kept_bash_commands
660 if [[ ${KEPT_COMMANDS} ]]
662 TOKEEP=$(mktemp /tmp/keep.XXXXXX)
665 echo "$@" > ${TOKEEP}
667 selector -b -i -d -l ${HISTSIZE} -o "${TOKEEP}" <(history)
670 if [[ -s "${TOKEEP}" ]]
672 echo $(date)": "$(cat ${TOKEEP}) >> ${KEPT_COMMANDS}
675 echo "No command stored!"
680 echo "You have to set \$KEPT_COMMANDS"
684 ######################################################################
685 # I sometime burn CDs and DVDs
688 [[ "${DEV_BURNER}" ]] || DEV_BURNER="/dev/sr0"
691 echo "burn <iso name | dirname>" >&2
694 if [[ $(file "$1" | \grep -E 'ISO 9660|UDF filesystem data') ]]
696 wodim -eject -v dev=${DEV_BURNER} "$1"
698 echo "Do not know what to do with $1" >&2
702 [[ "${TMP_ROOT}" ]] || TMP_ROOT=/tmp/
703 echo "Using ${TMP_ROOT} as temporary directory."
704 TMP=$(mktemp ${TMP_ROOT}/cdimage.XXXXXX) && \
705 genisoimage -input-charset iso8859-1 -r -o ${TMP} "$1" && \
706 wodim -eject -v dev=${DEV_BURNER} ${TMP}
709 echo "Can not find $1" >&2
713 ######################################################################
714 # And watch DVDs too!
719 echo " ! @ Seek to the beginning of the previous/next chapter"
720 echo " j Cycle through the available subtitles"
721 echo " o Show/hide the timing"
722 echo " x z Subtitle delay"
731 dvd_device="/dev/dvd"
742 # -vc ffmpeg12 -vf yadif
744 mplayer > /dev/null \
747 -alang en -slang en \
748 -softvol -softvol-max 1000 \
749 -dvd-device ${dvd_device} ${MPLAYER_OPTIONS} dvd://${title}
753 if [[ -e "/dev/dvd" ]]
755 DVD_DEVICE="/dev/dvd"
756 elif [[ -e "/dev/dvd3" ]]
758 DVD_DEVICE="/dev/dvd3"
760 echo "Can not find the dvd device." >&2
764 echo "Attemptin to rip from ${DVD_DEVICE}."
766 mkdir -p ${HOME}/dvds
769 time dvdbackup -i ${DVD_DEVICE} -v -M "$@" && eject
774 ######################################################################
775 # Create small images from images
777 function mksmall () {
779 if [[ "$1" == "--params" ]]
786 [[ "${PARAMS}" ]] || PARAMS="-geometry 1280x1024"
788 # Auto-orient does not seem to work at all, hence the ugly hack
791 # PARAMS="-auto-orient -geometry 800x600"
793 echo "Using ${PARAMS}"
797 [[ ${DEST_DIR} ]] || DEST_DIR=./small
801 if [[ ! -d ${DEST_DIR} ]]
803 echo "Can not create ${DEST_DIR}" >&2
807 NB_TOTAL=$(find -maxdepth 1 -type f | wc -l)
810 for i in $(find -maxdepth 1 -type f)
812 if [[ $(file $i | grep image) ]]
814 if [[ -e ${DEST_DIR}/$i ]]
816 echo "The file ${DEST_DIR}/$i already exists."
818 if [[ $(file ${i/%.*/}.* | grep -E movie) ]]
820 CAPTION_PARAMS="-font FreeSans-Bold -pointsize 32 -fill green -annotate +10+32 Video"
825 convert ${rotation_cmd} $i ${PARAMS} ${CAPTION_PARAMS} ${DEST_DIR}/$i
828 \ls -lt ${DEST_DIR}/$i
833 echo "$((NB*100/NB_TOTAL))% (${NB}/${NB_TOTAL})"
837 ######################################################################
838 # Move a file to the ~/sources/config directory and replace it where
839 # it was by a symbolic link
841 function mvtoconfig () {
842 CONFIGDIR=${HOME}/sources/config
843 if [[ -d ${CONFIGDIR} ]]
845 NEWNAME=${CONFIGDIR}/$(basename "$1" | sed -e "s/^\.//")
849 echo "Can not find ${CONFIGDIR}"
853 ######################################################################
854 # The complex prompt policy
858 if [[ "${CONSOLE}" == "yes" ]]
865 # If the login is a standard one (as specified in
866 # IGNORED_PROMPT_LOGIN, which is set in the private bash file), do not
867 # show it. I have IGNORED_PROMPT_LOGIN="^fleuret$".
869 if [[ ! ${IGNORED_PROMPT_LOGIN} ]] || [[ ! ${USER} =~ ${IGNORED_PROMPT_LOGIN} ]]
874 # If the display is not the main one, make the assumption that the
875 # shell is not running on the localhost, and show the hostname
877 [[ "${DISPLAY}" != ":0.0" ]] && IDENT="${IDENT}@\h"
879 # If there is the login or the hostname, add a ":" to the prompt
881 [[ "${IDENT}" ]] && IDENT="${IDENT}:"
883 if [[ ${USER} == "root" ]]
885 # If we are root, show that in red
886 PS1="\[${VT_RED_BG}${VT_WHITE_FG}\]${IDENT}\w\[${VT_RESET}\] "
888 if [[ $(\grep QEMU /proc/cpuinfo) ]]
890 # If we are in a qemu virtual machine, in yellow
891 PS1="\[${VT_YELLOW_BG}${VT_BLACK_FG}\]${IDENT}\w\[${VT_RESET}\] "
894 PS1="\[${VT_WHITE_BG}${VT_BLACK_FG}\]${IDENT}\w\[${VT_RESET}\] "
902 ######################################################################
903 # This implements a local history. If we are in a directory containing
904 # a writable local history file, we add the last line of the global
907 LOCAL_HISTORY_FILE=".local_bash_history"
909 function keep_local_history () {
910 if [[ -w "${LOCAL_HISTORY_FILE}" ]]
912 history 1 | sed -e 's/^ *[0-9]* *//' >> ${LOCAL_HISTORY_FILE}
913 TMP=$(mktemp /tmp/lh.XXXXXX)
915 uniq < ${LOCAL_HISTORY_FILE} | tail -${HISTSIZE} > ${TMP}
916 # mv would replace a symbolic link, while cp keeps it
917 \cp ${TMP} ${LOCAL_HISTORY_FILE}
919 LOCAL_HISTORY_HINT="* "
921 LOCAL_HISTORY_HINT=""
925 PS1="\[${VT_WHITE_BG}\]\${LOCAL_HISTORY_HINT}\[${VT_RESET}\]${PS1}"
927 ######################################################################
928 # Show the history path if it is unusual
930 function histfile_cue () {
931 if [[ ! "${HISTFILE}" == "${HOME}/.bash_history" ]]
933 HISTORY_CUE="[${HISTFILE}]"
939 PS1="\[${VT_YELLOW_BG}\]\${HISTORY_CUE}\[${VT_RESET}\]${PS1}"
941 ######################################################################
942 # The dus command is available on my web site
944 # git clone http://fleuret.org/git/dus/
946 alias dus='dus -f -i'
948 ######################################################################
949 # The finddup command is available on my web site
951 # git clone http://fleuret.org/git/finddup/
953 alias finddup='finddup -p'
955 ######################################################################
956 # The selector command is available on my web site
958 # git clone http://fleuret.org/git/selector/
960 export SELECTOR_CD_HISTORY_SIZE=10000
962 source bash-selector.sh --hist --cd
964 ######################################################################
965 # And we avoid to put in the history the use of the selector, which we
968 HISTIGNORE="${HISTIGNORE}:selector-history"
970 ######################################################################
972 function selector-printer () {
973 TMP=$(mktemp /tmp/selector-printer.XXXXXX)
974 selector -o ${TMP} <(lpstat -a | awk '{print $1}')
975 export PRINTER=$(cat ${TMP})
976 echo "PRINTER=${PRINTER}"
981 ######################################################################
982 # A ls with memory to notice what files have been added/removed from
983 # the current directory
986 [[ "${LSN_STATE_FILE}" ]] || LSN_STATE_FILE=".lsn-state"
988 if [[ $1 == "--mem" ]] || [[ "$1" == "-m" ]]
991 \ls -pa | sort > "${LSN_STATE_FILE}"
992 echo "State updated." >&2
999 TMP=$(mktemp /tmp/lsn.XXXXXX)
1000 \ls -d "$@" > ${TMP}
1001 cat "${LSN_STATE_FILE}" >> ${TMP}
1002 sort ${TMP} | uniq -u > "${LSN_STATE_FILE}"
1008 lsn [--help|-h] [--mem|-m] [+ <file> ...]
1016 stores the current state of the directory
1018 + <file> [<file> ...]
1019 switches the presence/absence of the indicated files in the
1023 if [[ ! "$1" == "-h" ]] && [[ ! "$1" == "--help" ]]
1025 echo >&2 "Unknown option \`\`$1''."
1031 if [[ -f "${LSN_STATE_FILE}" ]]
1033 TMP=$(mktemp /tmp/lsn.XXXXXX)
1034 \ls -pa | sort > ${TMP}
1035 if diff > /dev/null ${TMP} "${LSN_STATE_FILE}"
1037 echo "${VT_GREEN_FG}${VT_BOLD}No change (since $(date +"%b %d, %Y" -r "${LSN_STATE_FILE}"))${VT_RESET}"
1039 \comm -1 -3 "${LSN_STATE_FILE}" ${TMP}
1040 \comm -2 -3 "${LSN_STATE_FILE}" ${TMP} | while read line
1042 echo "${VT_RED_FG}${VT_BOLD}${line}${VT_RESET} (missing)"
1047 echo "${VT_RED_FG}${VT_BOLD}No lsn state here.${VT_RESET}" >&2
1054 ######################################################################
1056 function prompt_command () {
1057 [[ "${CORE_CHECK_PWD}" == ${PWD} ]] || find . -maxdepth 1 -name "core__*" | awk '{print "'${VT_RED_FG}'"$0"'${VT_RESET}'"}'
1058 CORE_CHECK_PWD=${PWD}
1060 # if [[ $(umask) != 0022 ]]
1062 # echo "Umask changed to $(umask)"
1064 # save the history after every command to avoid loosing some when
1065 # multiple shells are open
1067 # load the saved history
1069 # and the local histories system defined above
1071 # and the history cue
1075 PROMPT_COMMAND="prompt_command"
1077 ######################################################################
1079 # Displaying the timezone if it is set
1081 [[ ${TZ} ]] && echo "${VT_BLUE_FG}Time zone is ${TZ}.${VT_RESET}"
1083 ######################################################################